﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Input;
using Windows.UI;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;

namespace OrganizationDiagramSample.Model
{
    public class UserInfo : ObservableCollection<UserInfo>, INotifyPropertyChanged
    {
        private string fullName;
        private string firstName;
        private string lastName;
        private string title;
        private string roleName;
        private string picturepath;
        private string emailAlias;
        private string password;
        private string geoName;
        private State isexpand;
        private double _borderthick = 1;
        private string heatmap = "#FFC34444";

        public UserInfo()
        {
            Models = new ObservableCollection<UserInfo>();

        }

        public State IsExpand
        {
            get
            {
                return isexpand;
            }
            set
            {
                if (isexpand != value)
                {
                    isexpand = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("IsExpand"));
                }
            }
        }

        //private ObservableCollection<string> _disp = new ObservableCollection<string>()
        //{
        //    "Managing Director",
        //    "Project Manager",
        //    "Project Lead",
        //    "Senior S/w Engg",
        //    "S/w Engg",
        //    "Project Trainee"
        //};

        //public ObservableCollection<string> Designation
        //{
        //    get
        //    {
        //        return _disp;
        //    }
        //}

        //private ObservableCollection<string> _gen = new ObservableCollection<string>()
        //{
        //    "Female",
        //    "Male"
        //};

        //public ObservableCollection<string> Gender
        //{
        //    get
        //    {
        //        return _gen;
        //    }
        //}

        private NodeFocusState isfocus;
        public NodeFocusState IsFocus
        {
            get
            {
                return isfocus;
            }
            set
            {
                if (isfocus != value)
                {
                    isfocus = value;
                    if (value == NodeFocusState.Normal)
                    {
                        BackgroundBrush = new SolidColorBrush(Colors.White);
                    }
                    else if (value == NodeFocusState.MouseHover)
                    {
                        Color c = Color.FromArgb(255, 239, 239, 239);
                        BackgroundBrush = new SolidColorBrush(c);
                    }
                    else if (value == NodeFocusState.Focused)
                    {
                        BackgroundBrush = ColorConverter(RatingColor);
                    }
                    OnPropertyChanged(new PropertyChangedEventArgs("IsFocus"));
                }
            }
        }

        private SolidColorBrush ColorConverter(string hexaColor)
        {
            if (hexaColor != null)
            {
                byte r = Convert.ToByte(hexaColor.Substring(1, 2), 16);
                byte g = Convert.ToByte(hexaColor.Substring(3, 2), 16);
                byte b = Convert.ToByte(hexaColor.Substring(5, 2), 16);
                byte a = Convert.ToByte(hexaColor.Substring(7, 2), 16);
                SolidColorBrush myBrush = new SolidColorBrush(Color.FromArgb(r, g, b, a));
                return myBrush;
            }
            return null;
        }

        //public bool IsFiltered
        //{
        //    get
        //    {
        //        return isfilter;
        //    }
        //    set
        //    {
        //        if (isfilter != value)
        //        {
        //            isfilter = value;
        //            OnPropertyChanged(new PropertyChangedEventArgs("IsFiltered"));
        //        }
        //    }
        //}

        public string FullName
        {
            get
            {
                return fullName;
            }
            set
            {
                if (fullName != value)
                {
                    fullName = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("FullName"));
                }
            }
        }

        public string FirstName
        {
            get
            {
                return firstName;
            }
            set
            {
                if (firstName != value)
                {
                    firstName = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("FirstName"));
                }
            }
        }

        public string LastName
        {
            get
            {
                return lastName;
            }
            set
            {
                if (lastName != value)
                {
                    lastName = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("LastName"));
                }
            }
        }

        public string RoleName
        {
            get
            {
                return roleName;
            }
            set
            {
                if (roleName != value)
                {
                    roleName = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("RoleName"));
                }
            }
        }

        public string StandardTitle
        {
            get
            {
                return title;
            }
            set
            {
                if (title != value)
                {
                    title = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("StandardTitle"));
                }
            }
        }

        public string GeoName
        {
            get
            {
                return geoName;
            }
            set
            {
                if (geoName != value)
                {
                    geoName = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("GeoName"));
                }
            }
        }

        public string Picturepath
        {
            get
            {
                return picturepath;
            }
            set
            {
                if (picturepath != value)
                {
                    picturepath = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("Picturepath"));

                }
            }
        }

        public string EmailAlias
        {
            get
            {
                return emailAlias;
            }
            set
            {
                if (emailAlias != value)
                {
                    emailAlias = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("EmailAlias"));
                }
            }
        }

        public string Password
        {
            get
            {
                return password;
            }
            set
            {
                if (password != value)
                {
                    password = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("Password"));
                }
            }
        }

        public double BorderThickness
        {
            get
            {
                return _borderthick;
            }
            set
            {
                if (_borderthick != value)
                {
                    _borderthick = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("BorderThickness"));
                }
            }

        }

        public string RatingColor
        {
            get
            {
                return heatmap;
            }
            set
            {
                if (heatmap != value)
                {
                    if (value != null)
                    {
                        heatmap = value;
                        //if (RatingUpdated != null)
                        //{
                        //    RatingUpdated.Execute(RatingColor);
                        //}
                        OnPropertyChanged(new PropertyChangedEventArgs("RatingColor"));
                    }
                }
            }
        }

        //private ICommand _rating;

        //public ICommand RatingUpdated
        //{
        //    get
        //    {
        //        return _rating;
        //    }
        //    set
        //    {
        //        if (_rating != null)
        //        {
        //            _rating = value;
        //            OnPropertyChanged(new PropertyChangedEventArgs("RatingUpdated"));
        //        }
        //    }
        //}

        private ObservableCollection<UserInfo> models;

        public ObservableCollection<UserInfo> Models
        {
            get { return models; }
            set
            {
                models = value;
                OnPropertyChanged(new PropertyChangedEventArgs("Models"));
            }
        }

        public ICommand BrowseCommand
        {
            get
            {
                return null;//new DelegateCommand<object>(OnClick, args => { return true; });
            }
        }

        private ICommand _selection;

        public ICommand Selection
        {
            get
            {
                return _selection;
            }
            set
            {
                if (_selection != value)
                {
                    _selection = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("Selection"));
                }
            }
        }

        private BitmapImage _bit;

        public BitmapImage BitImag
        {
            get
            {
                return _bit;
            }
            set
            {
                if (_bit != value)
                {
                    _bit = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("BitImag"));
                }
            }
        }

        private void OnPress(object obj)
        {

        }

        private SolidColorBrush _backbrush;
        public SolidColorBrush BackgroundBrush
        {
            get
            {
                return _backbrush;
            }
            set
            {
                if (_backbrush != value)
                {
                    _backbrush = value;
                    OnPropertyChanged(new PropertyChangedEventArgs("BackgroundBrush"));
                }
            }
        }

        private void OnClick(object obj)
        {

        }

        //private async void OnClick(object obj)
        //{
        //    Image im = new Image();
        //    FileOpenPicker open = new FileOpenPicker();
        //    open.SuggestedStartLocation = PickerLocationId.PicturesLibrary;
        //    open.ViewMode = PickerViewMode.Thumbnail;

        //    // Filter to include a sample subset of file types
        //    open.FileTypeFilter.Clear();
        //    open.FileTypeFilter.Add(".bmp");
        //    open.FileTypeFilter.Add(".png");
        //    open.FileTypeFilter.Add(".jpeg");
        //    open.FileTypeFilter.Add(".jpg");

        //    // Open a stream for the selected file
        //    StorageFile file = await open.PickSingleFileAsync();

        //    // Ensure a file was selected
        //    if (file != null)
        //    {
        //        // Ensure the stream is disposed once the image is loaded
        //        using (IRandomAccessStream fileStream = await file.OpenAsync(Windows.Storage.FileAccessMode.Read))
        //        {
        //            await BitImag.SetSourceAsync(fileStream);
        //        }
        //        ImageUrl = file.Path;
        //    }
        //}
    }
    public enum AnimationState
    {
        Normal,
        Animation
    };

    public enum State
    {
        Expand,
        Collapse,
        None
    };

    public enum NodeFocusState
    {
        Normal,
        MouseHover,
        Focused
    };
}
