﻿using System;
using System.Linq;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238
using OrganizationDiagramSample.Model;
using OrganizationDiagramSample.Utilities;
using OrganizationDiagramSample.ViewModel;
using Syncfusion.UI.Xaml.Diagram;
using Syncfusion.UI.Xaml.Diagram.Layout;
using Windows.UI.Xaml.Data;

using ScrollViewer = Syncfusion.UI.Xaml.Diagram.Controls.ScrollViewer;

namespace OrganizationDiagramSample.View
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class PersonaSelection : Page
    {
        private IGraphInfo graphInfo;

        public ChartViewModel ChartViewModel
        {
            get { return (ChartViewModel)GetValue(ChartViewModelProperty); }
            set { SetValue(ChartViewModelProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ChartViewModel.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ChartViewModelProperty =
            DependencyProperty.Register("ChartViewModel", typeof(ChartViewModel), typeof(PersonaSelection), new PropertyMetadata(null, OnPropertyChangedCallBack));

        private static void OnPropertyChangedCallBack(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            try
            {
                PersonaSelection diagram = d as PersonaSelection;

                ChartViewModel chartvm = e.NewValue as ChartViewModel;
                diagram.UpdateCollection();
                chartvm.ShowProperties = new DelegateCommand<object>(diagram.OnShowProperties, args => { return true; });
                chartvm.Done = new DelegateCommand<object>(diagram.OnDone, args => { return true; });
                chartvm.Cancel = new DelegateCommand<object>(diagram.OnCancel, args => { return true; });
                chartvm.Previous = new DelegateCommand<object>(diagram.OnPrevious, args => { return true; });
                chartvm.Next = new DelegateCommand<object>(diagram.OnNext, args => { return true; });
                chartvm.Close = new DelegateCommand<object>(diagram.OnClose, args => { return true; });
                chartvm.Search = new DelegateCommand<object>(diagram.OnSearch, args => { return true; });
                chartvm.AddUser = new DelegateCommand<object>(diagram.AddUser, args => { return true; });
                chartvm.CloseAppBar = new DelegateCommand<object>(diagram.Closeappbar, args => { return true; });
            }
            catch (Exception)
            {

                throw;
            }
        }

        private void Closeappbar(object obj)
        {
            //throw new NotImplementedException();
        }

        private void AddUser(object obj)
        {
            //throw new NotImplementedException();
        }

        private void OnSearch(object obj)
        {
            //throw new NotImplementedException();
        }

        private void OnClose(object obj)
        {
            //throw new NotImplementedException();
        }

        private void OnNext(object obj)
        {
            //throw new NotImplementedException();
        }

        private void OnPrevious(object obj)
        {
            //throw new NotImplementedException();
        }

        private void OnCancel(object obj)
        {
            //throw new NotImplementedException();
        }

        private object Selected;
        private void OnDone(object obj)
        {
            if (Selected.ToString() == "Add")
            {
                OrgNodeViewModel org = new OrgNodeViewModel()
                {
                    Content = ChartViewModel.CreatedContent
                };
                org.IsNew = true;

                (ChartViewModel.NodeCollection as DiagramCollection<OrgNodeViewModel>).Add(org);
                OrgConnectorViewModel c = new OrgConnectorViewModel()
                {
                    SourceNode = (ChartViewModel.SelectedObject as OrgNodeViewModel),
                    TargetNode = org
                };
                (ChartViewModel.Connections as DiagramCollection<OrgConnectorViewModel>).Add(c);

                if (((c.SourceNode as OrgNodeViewModel).Content as UserInfo).IsExpand == State.Collapse)
                {
                    org.Visible = false;
                    c.Visible = false;
                    (ChartViewModel.SelectedObject as OrgNodeViewModel).IsExpanded = true;
                    ((ChartViewModel.SelectedObject as OrgNodeViewModel).Content as UserInfo).IsExpand = State.Expand;
                    Show((ChartViewModel.SelectedObject as OrgNodeViewModel));
                    UpdateLayout((ChartViewModel.SelectedObject as OrgNodeViewModel));
                }
                else
                {
                    ((ChartViewModel.SelectedObject as OrgNodeViewModel).Content as UserInfo).IsExpand = State.Expand;
                    sfdiagram.LayoutManager.Layout.UpdateLayout();
                }
                (org.Content as UserInfo).IsExpand = State.None;
            }
            else
            {
                ChartViewModel.CreatedContent = null;

            }
            //HideEditors();
        }

        private void OnShowProperties(object obj)
        {

        }

        private void UpdateCollection()
        {
            try
            {
                sfdiagram.Nodes = this.ChartViewModel.NodeCollection;
                sfdiagram.Connectors = this.ChartViewModel.Connections;
                sfdiagram.LayoutManager = new Syncfusion.UI.Xaml.Diagram.Layout.LayoutManager()
                {
                    Layout = new DirectedTreeLayout()
                    {
                        HorizontalSpacing = 20,
                        VerticalSpacing = 40,
                        SpaceBetweenSubTrees = 20
                    }
                };

                (sfdiagram.Nodes as DiagramCollection<OrgNodeViewModel>).CollectionChanged += OrgDiagram_CollectionChanged;
            }
            catch (Exception)
            {

                throw;
            }
        }

        private void OrgDiagram_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {

        }


        public PersonaSelection()
        {
            try
            {
                this.InitializeComponent();

                //this.ChartViewModel = new ChartViewModel();

                graphInfo = sfdiagram.Info as IGraphInfo;
                graphInfo.ItemTappedEvent += sfdiagram_ItemTappedEvent;
                sfdiagram.Loaded += sfdiagram_Loaded;
                
                graphInfo.ItemUnSelectedEvent += sfdiagram_ItemUnSelectedEvent;
                sfdiagram.Tapped += sfdiagram_Tapped;
                sfdiagram.DoubleTapped += sfdiagram_DoubleTapped;
                graphInfo.ItemDoubleTappedEvent += sfdiagram_ItemDoubleTappedEvent;
                sfdiagram.SFSelector.Style = this.Resources["CustomSelector"] as Style;
                sfdiagram.PointerMoved += sfdiagram_PointerMoved;
                sfdiagram.PageSettings = null;
                this.Loaded += OrgDiagram_Loaded;
                this.Unloaded += OrgDiagram_Unloaded;
            }
            catch (Exception)
            {
                
                throw;
            }

        }

        private void OrgDiagram_Unloaded(object sender, RoutedEventArgs e)
        {
            try
            {
                sfdiagram.LayoutManager = null;
                sfdiagram.ViewDictionary = null;
                this.Unloaded -= OrgDiagram_Unloaded;
                ChartViewModel.Dispose();
                foreach (IConnector connector in sfdiagram.Connectors)
                {
                    connector.SourceNode = null;
                    connector.TargetNode = null;
                }

                foreach (FrameworkElement child in sfdiagram.Page.Children)
                {
                    if (child is Node)
                    {
                        OrgNodeViewModel vm = child.DataContext as OrgNodeViewModel;
                        if (vm != null)
                        {
                            vm.CustomToolTip = null;
                        }
                        //child.Holding -= Node_Holding_1;
                        //child.PointerEntered -= Node_PointerEntered_1;
                        //child.PointerExited -= Node_PointerExited_1;
                        //child.PointerMoved -= Node_PointerMoved_1;
                        //child.PointerPressed -= Node_PointerPressed_1;
                    }
                    child.DataContext = null;
                }

                sfdiagram.Nodes = null;
                sfdiagram.Connectors = null;

                SelectorViewModel selec = sfdiagram.SelectedItems as SelectorViewModel;
                if (selec != null)
                {
                    selec.Connectors = null;
                    selec.Nodes = null;
                    selec.Groups = null;
                }
                sfdiagram.DataContext = null;
                sfdiagram.SFSelector = null;
                sfdiagram.SelectedItems = null;
                this.DataContext = null;
                DiagramCommand.SetCommand(sfdiagram, null);

                this.Loaded -= OrgDiagram_Loaded;
                this.Unloaded -= OrgDiagram_Unloaded;
                if (sfdiagram != null)
                {
                    graphInfo.ItemTappedEvent -= sfdiagram_ItemTappedEvent;
                    sfdiagram.Loaded -= sfdiagram_Loaded;
                    graphInfo.ItemUnSelectedEvent -= sfdiagram_ItemUnSelectedEvent;
                    sfdiagram.Tapped -= sfdiagram_Tapped;
                    sfdiagram.DoubleTapped -= sfdiagram_DoubleTapped;
                    graphInfo.ItemDoubleTappedEvent -= sfdiagram_ItemDoubleTappedEvent;
                    sfdiagram.PointerMoved -= sfdiagram_PointerMoved;
                }
            }
            catch (Exception)
            {
                
                throw;
            }
        }

        private void OrgDiagram_Loaded(object sender, RoutedEventArgs e)
        {
            try
            {
                this.Loaded -= OrgDiagram_Loaded;
                foreach (FrameworkElement child in sfdiagram.Page.Children)
                {
                    if (child is Node && !(child is Syncfusion.UI.Xaml.Diagram.Selector))
                    {
                        //child.Holding += Node_Holding_1;
                        //child.PointerEntered += Node_PointerEntered_1;
                        //child.PointerExited += Node_PointerExited_1;
                        //child.PointerMoved += Node_PointerMoved_1;
                        //child.PointerPressed += Node_PointerPressed_1;

                        Binding vis = new Binding();
                        vis.Path = new PropertyPath("Visible");
                        vis.Mode = BindingMode.TwoWay;
                        vis.Converter = new BoolToVisibiltyConverter();
                        child.SetBinding(Node.VisibilityProperty, vis);
                    }
                    else if (child is Connector)
                    {
                        Binding bin = new Binding();
                        bin.Path = new PropertyPath("Visible");
                        bin.Mode = BindingMode.TwoWay;
                        bin.Converter = new BoolToVisibiltyConverter();
                        child.SetBinding(Connector.VisibilityProperty, bin);


                        bin = new Binding();
                        bin.Path = new PropertyPath("ConnectorOpacity");
                        child.SetBinding(Connector.OpacityProperty, bin);
                    }
                }
            }
            catch (Exception)
            {
                
                throw;
            }
        }



        private void sfdiagram_PointerMoved(object sender, Windows.UI.Xaml.Input.PointerRoutedEventArgs e)
        {
            onUpdate();
        }

        private void onUpdate()
        {
            try
            {

                (this.ChartViewModel.ScrollViewer as ScrollViewer).MaxZoom = 2;
                (this.ChartViewModel.ScrollViewer as ScrollViewer).MinZoom = 0.4;
                if ((this.ChartViewModel.ScrollViewer as ScrollViewer).CurrentZoom >= 0.8)
                {
                    foreach (INode org in sfdiagram.Page.Children.OfType<INode>())
                    {
                        org.ContentTemplate = App.Current.Resources["UserInfoContentTemplate"] as DataTemplate;
                    }
                }
                else if ((this.ChartViewModel.ScrollViewer as ScrollViewer).CurrentZoom < 0.8)
                {
                    foreach (INode org in sfdiagram.Page.Children.OfType<INode>())
                    {
                        org.ContentTemplate = App.Current.Resources["ZoomOutContentTemplate"] as DataTemplate;
                    }
                }
            }
            catch (Exception)
            {
                
                throw;
            }
        }

        private void sfdiagram_ItemDoubleTappedEvent(object sender, DiagramEventArgs args)
        {
            try
            {
                if (args.Item is OrgNodeViewModel)
                {
                    ChartViewModel.SelectedObject = (args.Item as OrgNodeViewModel);
                    if (((args.Item as OrgNodeViewModel).Content as UserInfo).IsExpand == State.Expand)
                    {
                        ((args.Item as OrgNodeViewModel).Content as UserInfo).IsExpand = State.Collapse;
                        (args.Item as OrgNodeViewModel).IsExpanded = false;
                        Hide((args.Item as OrgNodeViewModel));

                    }
                    else if (((args.Item as OrgNodeViewModel).Content as UserInfo).IsExpand == State.Collapse)
                    {
                        ((args.Item as OrgNodeViewModel).Content as UserInfo).IsExpand = State.Expand;
                        (args.Item as OrgNodeViewModel).IsExpanded = true;
                        Show((args.Item as OrgNodeViewModel));
                    }
                    UpdateLayout((args.Item as OrgNodeViewModel));

                    CheckSearch((sender as OrgChartDiagram));
                }
                TimeSpan tapsDelay =
                   DateTime.Now - this.singleTapTime;
                this.isSingleTap = false;
                //HideContextMenu();
            }
            catch (Exception)
            {
                
                throw;
            }
        }

        private void Show(OrgNodeViewModel n)
        {
            try
            {
                if ((n.Content as UserInfo).IsExpand == State.Expand)
                {
                    foreach (OrgConnectorViewModel con in (n.Info as INodeInfo).OutConnectors)
                    {
                        (con.TargetNode as OrgNodeViewModel).Visible = true;
                        Show((con.TargetNode as OrgNodeViewModel));
                    }
                    //foreach (OrgNodeViewModel node in sfdiagram.Page.Children.OfType<Connector>()
                    //                  .Where(connector => connector.SourceNode == n)
                    //                  .Select(connector => connector.TargetNode))
                    //{                   
                    //   (node as OrgNodeViewModel).Visible = true;
                    //    Show(node);
                    //}
                }
            }
            catch (Exception)
            {
                
                throw;
            }
        }

        //Collapses the Child Nodes
        private void Hide(OrgNodeViewModel n)
        {
            try
            {
                foreach (OrgNodeViewModel node in sfdiagram.Page.Children.OfType<Connector>()
                                          .Where(connector => (connector.SourceNode as OrgNodeViewModel) == n)
                                          .Select(connector => (connector.TargetNode as OrgNodeViewModel)))
                {
                    foreach (Connector line in sfdiagram.Page.Children.OfType<Connector>()
                                      .Where(connector => connector.TargetNode == node || connector.SourceNode == node))
                    {

                        //line.Visibility = Visibility.Collapsed;

                        (line.DataContext as OrgConnectorViewModel).Visible = false;
                        CollapseAnimation(line);
                    }

                    foreach (Node v in sfdiagram.Page.Children.OfType<Node>())
                    {
                        if (v.DataContext == node)
                        {
                            CollapseAnimation(v);
                            //v.Visibility = Visibility.Collapsed;

                            (v.DataContext as OrgNodeViewModel).Visible = false;
                        }
                    }
                    Hide(node);
                }
            }
            catch (Exception)
            {
                
                throw;
            }
        }

        //Fade in animation 
        void ExpandAnimation(DependencyObject obj)
        {
            sb = new Storyboard();
            //Duration duration = new Duration(new TimeSpan(0,0,0,800));
            DoubleAnimationUsingKeyFrames rotation = new DoubleAnimationUsingKeyFrames();
            //sb.Duration = duration;
            double rotate = ((obj as Node).RenderTransform as CompositeTransform).Rotation;
            //rotation.Duration = duration;
            EasingDoubleKeyFrame ed = new EasingDoubleKeyFrame()
            {

                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0)),
                Value = 0,
                EasingFunction = new BackEase()
                {
                    EasingMode = EasingMode.EaseIn
                }
            };

            EasingDoubleKeyFrame ed1 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 300)),
                Value = 0.556,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };

            EasingDoubleKeyFrame ed2 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 600)),
                Value = 0,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };

            rotation.KeyFrames.Add(ed);
            rotation.KeyFrames.Add(ed1);
            rotation.KeyFrames.Add(ed2);

            DoubleAnimationUsingKeyFrames scalex = new DoubleAnimationUsingKeyFrames();
            double scale = ((obj as Node).RenderTransform as CompositeTransform).ScaleX;
            EasingDoubleKeyFrame scalex1 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0)),
                Value = 1,
                EasingFunction = new BackEase()
                {
                    EasingMode = EasingMode.EaseIn
                }
            };

            EasingDoubleKeyFrame scalex2 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 300)),
                Value = 0.999,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };

            EasingDoubleKeyFrame scalex3 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 600)),
                Value = 0.996,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };


            scalex.KeyFrames.Add(scalex1);
            scalex.KeyFrames.Add(scalex2);
            scalex.KeyFrames.Add(scalex3);

            DoubleAnimationUsingKeyFrames scaley = new DoubleAnimationUsingKeyFrames();

            EasingDoubleKeyFrame scaley1 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0)),
                Value = 1,
                EasingFunction = new BackEase()
                {
                    EasingMode = EasingMode.EaseIn
                }
            };

            EasingDoubleKeyFrame scaley2 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 300)),
                Value = 0.999,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };

            EasingDoubleKeyFrame scaley3 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 600)),
                Value = 0.996,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };

            scaley.KeyFrames.Add(scaley1);
            scaley.KeyFrames.Add(scaley2);
            scaley.KeyFrames.Add(scaley3);

            DoubleAnimationUsingKeyFrames translateX = new DoubleAnimationUsingKeyFrames();
            double x = ((obj as Node).RenderTransform as CompositeTransform).TranslateX;
            EasingDoubleKeyFrame translateX1 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0)),
                Value = x,
                EasingFunction = new BackEase()
                {
                    EasingMode = EasingMode.EaseIn
                }
            };

            EasingDoubleKeyFrame translateX2 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 300)),
                Value = x - 0.096,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };

            EasingDoubleKeyFrame translateX3 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 600)),
                Value = x - 0.5,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };
            translateX.KeyFrames.Add(translateX1);
            translateX.KeyFrames.Add(translateX2);
            translateX.KeyFrames.Add(translateX3);

            DoubleAnimationUsingKeyFrames translateY = new DoubleAnimationUsingKeyFrames();
            double y = ((obj as Node).RenderTransform as CompositeTransform).TranslateY;
            EasingDoubleKeyFrame translateY1 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0)),
                Value = y,
                EasingFunction = new BackEase()
                {
                    EasingMode = EasingMode.EaseIn
                }
            };

            EasingDoubleKeyFrame translateY2 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 300)),
                Value = y - 0.067,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };

            EasingDoubleKeyFrame translateY3 = new EasingDoubleKeyFrame()
            {
                KeyTime = KeyTime.FromTimeSpan(new TimeSpan(0, 0, 0, 0, 600)),
                Value = y + 0.246,
                EasingFunction = new BackEase()
                {
                    Amplitude = 2
                }
            };
            translateY.KeyFrames.Add(translateY1);
            translateY.KeyFrames.Add(translateY2);
            translateY.KeyFrames.Add(translateY3);


            Storyboard.SetTarget(rotation, ((obj as Node).RenderTransform as CompositeTransform));
            Storyboard.SetTargetProperty(rotation, "Rotation");

            Storyboard.SetTarget(scalex, ((obj as Node).RenderTransform as CompositeTransform));
            Storyboard.SetTargetProperty(scalex, "ScaleX");

            Storyboard.SetTarget(scaley, ((obj as Node).RenderTransform as CompositeTransform));
            Storyboard.SetTargetProperty(scaley, "ScaleY");

            Storyboard.SetTarget(translateX, ((obj as Node).RenderTransform as CompositeTransform));
            Storyboard.SetTargetProperty(translateX, "TranslateX");


            Storyboard.SetTarget(translateY, ((obj as Node).RenderTransform as CompositeTransform));
            Storyboard.SetTargetProperty(translateY, "TranslateY");

            sb.Children.Add(rotation);
            sb.Children.Add(scalex);
            sb.Children.Add(scaley);
            sb.Children.Add(translateX);
            sb.Children.Add(translateY);
            sb.Begin();
            sb.RepeatBehavior = RepeatBehavior.Forever;
        }

        //Fade out animation
        void CollapseAnimation(DependencyObject obj)
        {
            Duration duration = new Duration(TimeSpan.FromMilliseconds(300));
            // Create two DoubleAnimations and set their properties.
            DoubleAnimation myDoubleAnimation1 = new DoubleAnimation();
            myDoubleAnimation1.Duration = duration;
            Storyboard sb = new Storyboard();
            sb.Duration = duration;
            sb.Children.Add(myDoubleAnimation1);
            Storyboard.SetTarget(myDoubleAnimation1, obj);
            Storyboard.SetTargetProperty(myDoubleAnimation1, "Opacity");
            myDoubleAnimation1.From = 1d;
            myDoubleAnimation1.To = 0d;
            sb.Begin();
        }

        private void CheckSearch(OrgChartDiagram org)
        {
            if ((org.DataContext as ChartViewModel).SearchVisibility == Visibility.Visible)
            {
                (org.DataContext as ChartViewModel).Item = null;
            }
            else if ((org.DataContext as ChartViewModel).SearchVisibility == Visibility.Visible)
            {
                (org.DataContext as ChartViewModel).Item = null;
            }
        }

        private void UpdateLayout(INode node)
        {
            Node fixednode = null;
            foreach (Node n in sfdiagram.Page.Children.OfType<Node>())
            {
                if (n.GetType() != typeof(Syncfusion.UI.Xaml.Diagram.Selector))
                {
                    if (n.DataContext == node)
                    {
                        fixednode = n;
                    }
                }
            }

            sfdiagram.LayoutManager.Layout.UpdateLayout(node);

            foreach (Node n in sfdiagram.Page.Children.OfType<Node>())
            {
                if (n.GetType() != typeof(Syncfusion.UI.Xaml.Diagram.Selector))
                {
                    if (n.DataContext != node)
                    {
                        foreach (OrgNodeViewModel o in sfdiagram.Page.Children.OfType<Connector>()
                                  .Where(connector => connector.SourceNode == node)
                                  .Select(connector => connector.TargetNode))
                        {
                            if (n.DataContext != o)
                            {
                                ApplyMovement(n);
                            }
                        }
                    }
                }
            }

            ApplyAnimation(node as OrgNodeViewModel);
        }

        private void ApplyMovement(Node source)
        {
            Storyboard sb1 = new Storyboard();
            RepositionThemeAnimation rt = new RepositionThemeAnimation();
            // rt.Duration = duration;
            rt.SpeedRatio = 0.80;
            Point offx = new Point(((source.DataContext as OrgNodeViewModel).OffsetX - source.UnitWidth / 2), ((source.DataContext as OrgNodeViewModel).OffsetY + (source.DataContext as OrgNodeViewModel).UnitHeight / 2));
            rt.FromHorizontalOffset = -sfdiagram.Page.TransformToVisual(source).TransformPoint(offx).X;
            sb1.Children.Add(rt);
            Storyboard.SetTarget(rt, source);
            sb1.Begin();
            //return;
            //if (source.Visibility  == Visibility.Collapsed)
            //{
            //    return;
            //}

            //Point to = new Point(source.OffsetX - source.Width*source.Pivot.X,
            //                     source.OffsetY - source.Width*source.Pivot.Y);
            //Point off = new Point(((source.DataContext as OrgNodeViewModel).OffsetX - source.Width / 2), ((source.DataContext as OrgNodeViewModel).OffsetY + (source.DataContext as OrgNodeViewModel).Height / 2));
            //double ofx = -sfdiagram.Page.TransformToVisual(source).TransformPoint(off).X;

            //DoubleAnimation x = new DoubleAnimation();
            ////x.EasingFunction = new ExponentialEase() { EasingMode = EasingMode.EaseOut, Exponent = 2 };
            //x.Duration = new Duration(TimeSpan.FromMilliseconds(200));
            //x.From = to.X + ofx;
            //x.To = to.X;
            ////y.To = to.Y;
            //Storyboard.SetTarget(x, source.RenderTransform);
            //Storyboard.SetTargetProperty(x, "TranslateX");
            //Storyboard sb = new Storyboard();
            //sb.Children.Add(x);
            //sb.Duration = new Duration(TimeSpan.FromMilliseconds(200));
            //sb.Begin();
        }

        //Expands the Child Nodes
        private void ApplyAnimation(OrgNodeViewModel n)
        {
            Connector con = null;
            if ((n.Content as UserInfo).IsExpand == State.Expand)
            {
                foreach (OrgConnectorViewModel con1 in (n.Info as INodeInfo).OutConnectors)
                {
                    foreach (Connector line in sfdiagram.Page.Children.OfType<Connector>()
                                 .Where(connector => connector.TargetNode == con1.TargetNode || connector.SourceNode == con1.TargetNode))
                    {
                        if (line.SourceNode == n || line.TargetNode == n)
                            con = line;
                    }

                    foreach (Node v in sfdiagram.Page.Children.OfType<Node>())
                    {
                        if (v.DataContext == con1.TargetNode)
                        {
                            ExpandAnimation(v, n as OrgNodeViewModel, con);
                        }
                    }

                    ApplyAnimation(con1.TargetNode as OrgNodeViewModel);
                }
            }
        }

        private void OpacityAnimation(DependencyObject obj)
        {
            Duration duration = new Duration(TimeSpan.FromMilliseconds(300));
            DoubleAnimation myDoubleAnimation1 = new DoubleAnimation();
            myDoubleAnimation1.Duration = duration;
            Storyboard sb = new Storyboard();
            sb.Duration = duration;
            sb.Children.Add(myDoubleAnimation1);
            Storyboard.SetTarget(myDoubleAnimation1, obj);
            Storyboard.SetTargetProperty(myDoubleAnimation1, "Opacity");
            myDoubleAnimation1.From = 0d;
            myDoubleAnimation1.To = 1d;
            sb.Begin();
        }

        Storyboard sb1;
        private void ExpandAnimation(Node children, OrgNodeViewModel source, Connector org)
        {
            Node sourcenode = null;
            foreach (Node node in sfdiagram.Page.Children.OfType<Node>())
            {
                if (node.DataContext == source)
                {
                    sourcenode = node;
                }
            }
            OpacityAnimation(children);
            if (sourcenode != null)
            {
                DateTime dt = DateTime.Now;
                sb1 = new Storyboard();
                TransitionCollection tc = new TransitionCollection();
                RepositionThemeAnimation rt = new RepositionThemeAnimation();
                rt.SpeedRatio = 0.80;
                Point offx = new Point(((source as OrgNodeViewModel).OffsetX - source.UnitWidth / 2), ((source as OrgNodeViewModel).OffsetY + (source as OrgNodeViewModel).UnitHeight / 2));
                rt.FromHorizontalOffset = -sfdiagram.Page.TransformToVisual(sourcenode).TransformPoint(offx).X;
                rt.FromVerticalOffset = -sfdiagram.Page.TransformToVisual(sourcenode).TransformPoint(offx).Y;
                sb1.Children.Add(rt);
                Storyboard.SetTarget(rt, children);
                sb1.Begin();
                sb1.Completed += (s, e) =>
                {
                    if (ChartViewModel.SelectedObject != null)
                    {
                        if (((ChartViewModel.SelectedObject as OrgNodeViewModel).Content as UserInfo).IsExpand == State.Expand)
                        {
                            Update((ChartViewModel.SelectedObject as OrgNodeViewModel));
                        }
                    }
                };
            }
        }

        private void Update(OrgNodeViewModel n)
        {
            if ((n.Content as UserInfo).IsExpand == State.Expand)
            {
                foreach (OrgConnectorViewModel con in (n.Info as INodeInfo).OutConnectors)
                {
                    (con.TargetNode as OrgNodeViewModel).Visible = true;
                    foreach (Connector line in sfdiagram.Page.Children.OfType<Connector>()
                                 .Where(connector => connector.TargetNode == con.TargetNode || connector.SourceNode == con.TargetNode))
                    {
                        if (line.SourceNode == n || line.TargetNode == n)
                        {
                            (line.DataContext as OrgConnectorViewModel).Visible = true;
                            OpacityAnimation(line);
                        }
                    }
                    Update((con.TargetNode as OrgNodeViewModel));
                }

            }
        }

        private void sfdiagram_DoubleTapped(object sender, Windows.UI.Xaml.Input.DoubleTappedRoutedEventArgs e)
        {
            UIElement ui = e.OriginalSource as UIElement;
            ////Control co = ui.GetParent<Node>();
            //if (co != null)
            //{

            //}
        }

        private const int DOUBLETAP_DELAY_MILLIS = 700;
        private DateTime singleTapTime;
        private bool isSingleTap = true;
        private Point TapPoint;
        private object ClickedItem = "";
        Storyboard sb = null;
        async void sfdiagram_Tapped(object sender, Windows.UI.Xaml.Input.TappedRoutedEventArgs e)
        {
            UIElement ui = e.OriginalSource as UIElement;
            TapPoint = e.GetPosition(null);
            //foreach (var elemant in VisualTreeHelper.FindElementsInHostCoordinates(e.GetPosition(null), null))
            //{
            //    if (elemant is Grid)
            //    {

            //    }
            //    if (elemant is Node)
            //    {
            //        this.singleTapTime = DateTime.Now;

            //        await Task.Delay(DOUBLETAP_DELAY_MILLIS + 10);

            //        if (this.isSingleTap)
            //        {
            //            //Windows.UI.Xaml.Shapes.Path child = (elemant as Node).FindChild<Windows.UI.Xaml.Shapes.Path>();
            //            //child.Tapped += child_Tapped;
            //            if (((elemant as Node).DataContext as OrgNodeViewModel).Content is UserInfo)
            //            {
            //                //menus.Visibility = Visibility.Visible;
            //                contextmenu.Visibility = Visibility.Visible;
            //                ShowContextMenu();
            //                HidePopup((elemant as Node).DataContext as OrgNodeViewModel);
            //            }
            //        }
            //        return;
            //    }
            //    else if (elemant is SfDiagram)
            //    {
            //        HideContextMenu();
            //        HideEditors();
            //        return;
            //    }
            //}

            if (ClickedItem.ToString() == "Reassign")
            {
                if (sb != null)
                {
                    sb.Stop();
                    if ((ChartViewModel.SelectedObject as OrgNodeViewModel) != null)
                    {
                        //UpdateConnector((ChartViewModel.SelectedObject as OrgNodeViewModel), true);
                        //CancelReassign((ChartViewModel.SelectedObject as OrgNodeViewModel));
                        //ClickedItem = "";
                        //(ChartViewModel.SelectedObject as OrgNodeViewModel).Constraints = (ChartViewModel.SelectedObject as OrgNodeViewModel).Constraints | NodeConstraints.AllowPan;
                        //sfdiagram.Tool = sfdiagram.Tool | Tool.ZoomPan;
                        //sfdiagram.Constraints = sfdiagram.Constraints | GraphConstraints.Zoomable | GraphConstraints.Pannable;
                        //HidePopup((ChartViewModel.SelectedObject as OrgNodeViewModel));
                    }
                }
            }
            else
            {
                if (ChartViewModel.SelectedObject != null)
                {
                    ApplyDefultStyle((ChartViewModel.SelectedObject as OrgNodeViewModel));
                }

                ChartViewModel.SelectedObject = null;
                //if (PreviousSelectedItem != null)
                //{
                //    ((PreviousSelectedItem as OrgNodeViewModel).Content as UserInfo).IsFocus = NodeFocusState.Normal;
                //}

            }

            isSingleTap = true;
        }

        private void sfdiagram_ItemUnSelectedEvent(object sender, DiagramEventArgs args)
        {
            //throw new System.NotImplementedException();
        }

        private void sfdiagram_Loaded(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            GetScrollViewer((sender as SfDiagram));

            //foreach (var item in (sender as SfDiagram).Page.Children.OfType<Node>())
            //{
            //    if (item.GetType() != typeof(Syncfusion.UI.Xaml.Diagram.Selector))
            //    {
            //        if (((item as Node).DataContext as OrgNodeViewModel).Content is UserInfo)
            //        {
            //            (item as Node).AddHandler(Node.ManipulationStartedEvent, new ManipulationStartedEventHandler(nodes_ManipulationStarted_1), true);
            //            (item as Node).AddHandler(Node.ManipulationDeltaEvent, new ManipulationDeltaEventHandler(nodes_ManipulationDelta_1), true);
            //            (item as Node).AddHandler(Node.ManipulationCompletedEvent, new ManipulationCompletedEventHandler(nodes_ManipulationCompleted_1), true);
            //            (item as Node).ManipulationMode = ManipulationModes.System;
            //        }
            //    }
            //}
        }

        object PreviousSelectedItem = null;
        private void sfdiagram_ItemTappedEvent(object sender, DiagramEventArgs args)
        {
            if (args.Item is INode)
            {
                if ((args.Item as OrgNodeViewModel).Content is UserInfo)
                {

                    if (PreviousSelectedItem != null)
                    {
                        ((PreviousSelectedItem as OrgNodeViewModel).Content as UserInfo).IsFocus = NodeFocusState.Normal;
                        ApplyDefultStyle((PreviousSelectedItem as OrgNodeViewModel));
                    }
                    ChartViewModel.SelectedObject = (args.Item as OrgNodeViewModel);
                    ((ChartViewModel.SelectedObject as OrgNodeViewModel).Content as UserInfo).IsFocus = NodeFocusState.Focused;
                    ApplySelectedStyle((ChartViewModel.SelectedObject as OrgNodeViewModel));
                    PreviousSelectedItem = ChartViewModel.SelectedObject;
                    //((args.Item as OrgNodeViewModel).Content as UserInfo).PathClickCommand = new DelegateCommand<object>(OnPress, argus => { return true; });
                    //((args.Item as OrgNodeViewModel).Content as UserInfo).RatingCommand = new DelegateCommand<object>(OnRatingChanged, argus => { return true; });
                }
                //HidePopup((args.Item as OrgNodeViewModel));
            }
        }

        private void ApplySelectedStyle(OrgNodeViewModel orgNodeViewModel)
        {
            foreach (Node node in sfdiagram.Page.Children.OfType<Node>())
            {
                if (node.DataContext == orgNodeViewModel)
                {
                    //b = node.FindDescendantByName("mainborder") as Border;
                    //if(b!=null)
                    //b.Background = ColorConverter((orgNodeViewModel.Content as UserInfo).RatingColor);
                    //TextBlock t = node.FindDescendantByName("Name") as TextBlock;
                    //if(t!=null)
                    //t.Foreground = new SolidColorBrush(Colors.White);
                    //TextBlock t1 = node.FindDescendantByName("Destination") as TextBlock;
                    //if(t1!=null)
                    //t1.Foreground = new SolidColorBrush(Colors.White);
                    //TextBlock t2 = node.FindDescendantByName("EmailId") as TextBlock;
                    //if(t2!=null)
                    //t2.Foreground = new SolidColorBrush(Colors.White);
                    //TextBlock t3 = node.FindDescendantByName("ContactNo") as TextBlock;
                    //if(t3!=null)
                    //t3.Foreground = new SolidColorBrush(Colors.White);
                }
            }
        }

        private void ApplyDefultStyle(OrgNodeViewModel orgNodeViewModel)
        {
            foreach (Node node in sfdiagram.Page.Children.OfType<Node>())
            {
                if (node.DataContext == orgNodeViewModel)
                {
                    //b1 = node.FindDescendantByName("mainborder") as Border;
                    //if (b1 != null)
                    //b1.Background = new SolidColorBrush(Colors.White);
                    //TextBlock t = node.FindDescendantByName("Name") as TextBlock;
                    //if (t != null)
                    //t.Foreground = ColorConverter("#FF201F1A");
                    //TextBlock t1 = node.FindDescendantByName("Destination") as TextBlock;
                    //if (t1 != null)
                    //t1.Foreground = ColorConverter("#FF201F1A");
                    //TextBlock t2 = node.FindDescendantByName("EmailId") as TextBlock;
                    //if (t2 != null)
                    //t2.Foreground = ColorConverter("#FF201F1A");
                    //TextBlock t3 = node.FindDescendantByName("ContactNo") as TextBlock;
                    //if (t3 != null)
                    //t3.Foreground = ColorConverter("#FF201F1A");
                }
            }
        }

        private bool GetScrollViewer(DependencyObject sfd)
        {
            try
            {
                if (sfd is ScrollViewer)
                {
                    (this.DataContext as ChartViewModel).ScrollViewer = (sfd as ScrollViewer);
                    return true;
                }
                for (int i = 0; i < VisualTreeHelper.GetChildrenCount(sfd); i++)
                {
                    if (GetScrollViewer(VisualTreeHelper.GetChild(sfd, i)))
                    {
                        return true;
                    }
                }
                return false;
            }
            catch (Exception)
            {
                
               return false;
            }
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }
    }
}
