﻿using OrganizationDiagramSample.Model;
using Syncfusion.UI.Xaml.Diagram;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Windows.Foundation;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Shapes;

namespace OrganizationDiagramSample.ViewModel
{
    public class ChartViewModel : INotifyPropertyChanged, IDisposable
    {
        //SearchViewModel s;
        SingleGroup root;
        //private IPersonaService _personaService;

        public ChartViewModel()
        {
            //var _personaService = new PersonaService();
            //PersonaOrgDisplayData = _personaService.GetPersonaList();
            var list = App.Current.Resources["orgTree"] as UserInfo;
            //list.Models = PersonaOrgDisplayData;

            //Modeldata = App.Current.Resources["orgTree"] as UserInfo;
            Modeldata = list;
            root = new SingleGroup(Modeldata);
            root.MCollectionNodes();
            root.MCollectionConnectors();
            NodeCollection = root.CollectionNodes;
            Connections = root.CollectionConnectors;
        }

        #region Properties

        private UserInfo _personaOrgDisplayData;
        public UserInfo PersonaOrgDisplayData
        {
            get
            {
                return _personaOrgDisplayData;
            }
            set
            {
                if (_personaOrgDisplayData == value)
                {
                    return;
                }
                _personaOrgDisplayData = value;
                OnPropertyChanged("PersonelDisplayData");
            }
        }

        private Visibility textWaterMark = Visibility.Visible;

        public Visibility TextWaterMark
        {
            get
            {
                return textWaterMark;
            }
            set
            {
                if (textWaterMark != value)
                {
                    textWaterMark = value;
                    OnPropertyChanged("TextWaterMark");
                }
            }

        }

        private Visibility comboWaterMark = Visibility.Visible;

        public Visibility ComboboxWaterMark
        {
            get
            {
                return comboWaterMark;
            }
            set
            {
                if (comboWaterMark != value)
                {
                    comboWaterMark = value;
                    OnPropertyChanged("ComboboxWaterMark");
                }
            }

        }

        public UserInfo Modeldata
        {
            get;
            set;
        }


        //public SearchViewModel Searchview
        //{
        //    get;
        //    set;
        //}
        public IEnumerable<object> Connections
        {
            get;
            set;
        }

        public IEnumerable<object> NodeCollection
        {
            get;
            set;
        }

        private IEnumerable<object> TConnections
        {
            get;
            set;
        }

        private IEnumerable<object> TNodeCollection
        {
            get;
            set;
        }

        private object _createcontent;

        public object CreatedContent
        {
            get
            {
                return _createcontent;
            }
            set
            {
                if (_createcontent != value)
                {
                    _createcontent = value;
                    OnPropertyChanged("CreatedContent");
                }
            }
        }

        private ICommand _done;
        public ICommand Done
        {
            get
            {
                return _done;
            }
            set
            {
                if (_done != value)
                {
                    _done = value;
                    OnPropertyChanged("Done");
                }
            }
        }
        private ICommand _cancel;
        public ICommand Cancel
        {
            get
            {
                return _cancel;
            }
            set
            {
                if (_cancel != value)
                {
                    _cancel = value;
                    OnPropertyChanged("Cancel");
                }
            }
        }


        private string filterSelection = "Search";
        public string FilterSelection
        {
            get
            {
                return filterSelection;
            }
            set
            {
                filterSelection = value;
                OnPropertyChanged("FilterSelection");
            }
        }

        private string filterOption = "Name";
        public string FilterOption
        {
            get { return filterOption; }
            set
            {
                filterOption = value;
                OnPropertyChanged("FilterOption");
                //CreatenewSearch();
            }
        }

        //private void CreatenewSearch()
        //{
        //    Searchview = new SearchViewModel();
        //}

        private string filterText = string.Empty;

        public string FilterText
        {
            get { return filterText; }
            set
            {
                filterText = value;
                OnPropertyChanged("FilterText");
            }
        }

        private string filterCondition;

        public string FilterCondition
        {
            get { return filterCondition; }
            set
            {
                filterCondition = value;
                OnPropertyChanged("FilterCondition");
                //CreatenewSearch();
            }
        }

        private object _selected;

        public object SelectedObject
        {
            get
            {
                return _selected;
            }
            set
            {
                if (_selected != value)
                {
                    _selected = value;
                    if (_selected != null)
                    {
                        ((_selected as OrgNodeViewModel).Content as UserInfo).IsFocus = NodeFocusState.Focused;
                    }
                    OnPropertyChanged("SelectedObject");
                }
            }
        }

        private ICommand _show;

        public ICommand ShowProperties
        {
            get
            {
                return _show;
            }
            set
            {
                if (_show != value)
                {
                    _show = value;
                    OnPropertyChanged("ShowProperties");
                }
            }
        }

        #endregion

        #region Commands

        public object ScrollViewer
        {
            get;
            set;
        }

        private ICommand textchanged;

        public ICommand TextChanged
        {
            get { return new DelegateCommand<object>(TextChangeEvent, args => true); }
            set { textchanged = value; OnPropertyChanged("TextChanged"); }
        }

        public ICommand ComboChanged
        {
            get { return new DelegateCommand<object>(ComboxChangedEvent, args => { return true; }); }
        }

        public ICommand FilterComboChanged
        {
            get { return new DelegateCommand<object>(FilterComboxChangedEvent, args => { return true; }); }
        }

        private void FilterComboxChangedEvent(object pram)
        {
            if (pram != null)
            {
                if ((pram as ComboBox).SelectedItem != null)
                {
                    ComboboxWaterMark = Visibility.Collapsed;
                    this.FilterOption = ((pram as ComboBox).SelectedItem as ComboBoxItem).Content.ToString();
                    this.Item = null;
                }
                else
                {
                    (pram as ComboBox).SelectedIndex = 0;
                }
            }
        }

        public ICommand VertexTapped
        {
            get { return new DelegateCommand<object>(VTapped, args => { return true; }); }
        }

        private void ComboxChangedEvent(object pram)
        {
            if (pram != null)
            {
                this.FilterCondition = (pram as ComboBoxItem).Content.ToString();
            }
        }

        private void TextChangeEvent(object pram)
        {
            if (pram != null)
            {
                TextWaterMark = Visibility.Collapsed;
                this.FilterText = pram.ToString();
                this.Item = null;
                //StartSearch();
            }
        }

        private void VTapped(object obj)
        {

        }
        #endregion

        private ICommand _mcloseappbar;
        public ICommand CloseAppBar
        {
            get
            {
                return _mcloseappbar;
            }
            set
            {
                if (_mcloseappbar != value)
                {
                    _mcloseappbar = value;
                    OnPropertyChanged("CloseAppBar");
                }
            }
        }


        //public void FilerRecords(object o)
        //{
        //    var item = o as UserInfo;
        //    if (item != null && FilterText.Equals(""))
        //    {
        //        return;
        //    }
        //    else
        //    {
        //        if (item != null)
        //        {
        //            Searchview.UpdateSearch(root.CollectionNodes, root.CollectionConnectors, this.FilterText.ToString(), this.FilterOption.ToString(), "Search");

        //        }
        //    }
        //}

        private ICommand _search;

        public ICommand Search
        {
            get
            {
                return _search;
            }
            set
            {
                if (_search != value)
                {
                    _search = value;
                    OnPropertyChanged("Search");
                }
            }
        }


        private ICommand _add;

        public ICommand AddUser
        {
            get
            {
                return _add;
            }
            set
            {
                if (_add != value)
                {
                    _add = value;
                    OnPropertyChanged("AddUser");
                }
            }
        }

        private Visibility searchvisibility = Visibility.Collapsed;

        public Visibility SearchVisibility
        {
            get
            {
                return searchvisibility;
            }
            set
            {
                if (searchvisibility != value)
                {
                    searchvisibility = value;
                    OnPropertyChanged("SearchVisibility");
                }
            }
        }

        private ICommand _close;

        public ICommand Close
        {
            get
            {
                return _close;
            }
            set
            {
                if (_close != value)
                {
                    _close = value;
                    OnPropertyChanged("Close");
                }
            }
        }

        private ICommand _movepre;

        public ICommand Previous
        {
            get
            {
                return _movepre;
            }
            set
            {
                if (_movepre != value)
                {
                    _movepre = value;
                    OnPropertyChanged("Previous");
                }
            }
        }

        private ICommand _movenext;

        public ICommand Next
        {
            get
            {
                return _movenext;
            }
            set
            {
                if (_movenext != value)
                {
                    _movenext = value;
                    OnPropertyChanged("Next");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string propertyName)
        {
            try
            {
                PropertyChangedEventHandler handler = PropertyChanged;
                if (handler != null)
                {
                    var e = new PropertyChangedEventArgs(propertyName);
                    handler(this, e);
                }
            }
            catch (Exception)
            {
                
                throw;
            }
        }

        internal IEnumerator<OrgNodeViewModel> Item;
        internal delegate void FilterChanged();


        //internal void StartSearch()
        //{
        //    this.Searchview.UpdateSearch(root.CollectionNodes, root.CollectionConnectors, this.FilterText, this.FilterOption, this.FilterSelection);
        //}

        public void Dispose()
        {
            this.root = null;
            NodeCollection = null;
            Connections = null;
            //Searchview = null;

            this.AddUser = null;
            this.Cancel = null;
            this.Close = null;
            this.CreatedContent = null;
            this.Done = null;
            this.FilterCondition = null;
            this.FilterOption = null;
            this.FilterSelection = null;
            this.FilterText = null;
            this.Modeldata = null;
            this.Next = null;
            this.Previous = null;
            this.Search = null;
            //this.Searchview = null;
            this.SelectedObject = null;
            this.TConnections = null;
            this.TextChanged = null;
            this.TNodeCollection = null;
            this.ScrollViewer = null;
        }
    }
    public class SingleGroup
    {
        #region Properties

        private UserInfo _mSource;
        public DiagramCollection<OrgNodeViewModel> CollectionNodes
        {
            get;
            set;
        }

        public DiagramCollection<OrgConnectorViewModel> CollectionConnectors
        {
            get;
            set;
        }

        public void MCollectionNodes()
        {
            foreach (IEnumerable<UserInfo> item in GetNodes(_mSource))
            {

                OrgNodeViewModel d = new OrgNodeViewModel() { Content = item };
                d.ID = (item as UserInfo).EmailAlias;

                if ((item as UserInfo).IsExpand == State.Collapse)
                {
                    d.IsExpanded = false;
                }

                (CollectionNodes as DiagramCollection<OrgNodeViewModel>).Add(d);

            }
        }


        public void MCollectionConnectors()
        {
            //get
            //{
            foreach (OrgConnectorViewModel item in GetConnectors(_mSource))
            {
                //yield return item;
            }
            //}
        }
        #endregion


        public SingleGroup(UserInfo UserInfo)
        {
            CollectionNodes = new DiagramCollection<OrgNodeViewModel>();
            CollectionConnectors = new DiagramCollection<OrgConnectorViewModel>();
            _mSource = UserInfo;
            W = 100;
            H = 100;
        }

        private IEnumerable<UserInfo> GetNodes(UserInfo parent)
        {
            foreach (var child in parent)
            {
                if (!(parent as UserInfo).Models.Contains(child))
                    (parent as UserInfo).Models.Add(child);
                yield return child;
                foreach (var sub in GetNodes(child))
                {
                    yield return sub;
                }
            }
        }

        int count = 0;
        private IEnumerable<ConnectorViewModel> GetConnectors(UserInfo parent)
        {

            foreach (var child in parent)
            {
                if (count != 0)
                {
                    OrgConnectorViewModel cc = new OrgConnectorViewModel();
                    foreach (var item in CollectionNodes.OfType<OrgNodeViewModel>())
                    {
                        if (((item as OrgNodeViewModel).Content as UserInfo) == parent)
                        {
                            cc.SourceNode = (item as OrgNodeViewModel);
                        }
                    }
                    foreach (var item in CollectionNodes.OfType<OrgNodeViewModel>())
                    {
                        if ((item as OrgNodeViewModel).Content == child)
                        {
                            cc.TargetNode = (item as OrgNodeViewModel);
                        }
                    }
                   
                    cc.Constraints = ConnectorConstraints.None;
                    (CollectionConnectors as DiagramCollection<OrgConnectorViewModel>).Add(cc);
                    yield return cc;
                }
                count = count + 1;
                foreach (var sub in GetConnectors(child))
                {
                    yield return sub;
                }
            }
        }

        private Style GetDecoratorStyle()
        {
            Style s = new Style();
            s.TargetType = typeof(Windows.UI.Xaml.Shapes.Path);
            s.Setters.Add(new Setter(Windows.UI.Xaml.Shapes.Path.FillProperty, new SolidColorBrush(Colors.Black)));
            s.Setters.Add(new Setter(Windows.UI.Xaml.Shapes.Path.StrokeProperty, new SolidColorBrush(Colors.Black)));
            s.Setters.Add(new Setter(Windows.UI.Xaml.Shapes.Path.StretchProperty, Stretch.Fill));
            s.Setters.Add(new Setter(Windows.UI.Xaml.Shapes.Path.WidthProperty, 10));
            s.Setters.Add(new Setter(Windows.UI.Xaml.Shapes.Path.HeightProperty, 10));
            return s;
        }

        private Style GetStyle()
        {
            Style s = new Style();
            s.TargetType = typeof(Windows.UI.Xaml.Shapes.Path);
            s.Setters.Add(new Setter(Windows.UI.Xaml.Shapes.Path.StrokeProperty, new SolidColorBrush(Colors.Black)));
            return s;
        }

        //public IEnumerable<object> MConnectors
        //{

        //}

        [PropertyMapping(Property = "Width")]
        public double W { get; set; }

        [PropertyMapping(Property = "Height")]
        public double H { get; set; }
    }

    public class DelegateCommand<T> : ICommand
    {
        private Predicate<T> _canExecute;
        private Action<T> _method;
        bool _canExecuteCache = true;

        /// <summary>
        /// Initializes a new instance of the <see cref="DelegateCommand"/> class.
        /// </summary>
        /// <param name="method">The method.</param>
        public DelegateCommand(Action<T> method)
            : this(method, null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DelegateCommand"/> class.
        /// </summary>
        /// <param name="method">The method.</param>
        /// <param name="canExecute">The can execute.</param>
        public DelegateCommand(Action<T> method, Predicate<T> canExecute)
        {
            _method = method;
            _canExecute = canExecute;
        }

        public DelegateCommand(ICommand Clicked, Predicate<object> predicate)
        {
            // TODO: Complete member initialization
            this.Clicked = Clicked;
            this.predicate = predicate;
        }

        /// <summary>
        /// Defines the method that determines whether the command can execute in its current state.
        /// </summary>
        /// <param name="parameter">Data used by the command.  If the command does not require data to be passed, this object can be set to null.</param>
        /// <returns>
        /// true if this command can be executed; otherwise, false.
        /// </returns>
        public bool CanExecute(object parameter)
        {
            if (_canExecute != null && parameter != null)
            {
                bool tempCanExecute = _canExecute((T) parameter);

                if (_canExecuteCache != tempCanExecute)
                {
                    _canExecuteCache = tempCanExecute;
                    if (CanExecuteChanged != null)
                    {
                        CanExecuteChanged(this, new EventArgs());
                    }
                }
            }

            return _canExecuteCache;

        }

        /// <summary>
        /// Defines the method to be called when the command is invoked.
        /// </summary>
        /// <param name="parameter">Data used by the command.  If the command does not require data to be passed, this object can be set to null.</param>
        public void Execute(object parameter)
        {
            if (_method != null && parameter != null)
                _method.Invoke((T)parameter);
        }

        #region ICommand Members

        public event EventHandler CanExecuteChanged;
        private ICommand Clicked;
        private Predicate<object> predicate;

        #endregion
    }
}
